This page is intended to keep track of the growing number of Truffle language implementations and experiments.

## Language implementations

* [Graal.js](https://github.com/graalvm/graaljs), an ECMAScript 2017 compliant JavaScript implementation. *
* [FastR](https://github.com/graalvm/fastr), an implementation of GNU R. *
* [TruffleRuby](https://github.com/graalvm/truffleruby), an implementation of Ruby. *
* [Sulong](https://github.com/oracle/graal/tree/master/sulong), an LLVM bitcode interpreter. *
* [Graal.Python](https://github.com/graalvm/graalpython), an early-stage implementation of Python. *
* [TruffleSOM](https://github.com/SOM-st/TruffleSOM), a SOM Smalltalk implementation.
* [SOMns](https://github.com/smarr/SOMns), a Newspeak implementation for Concurrency Research.
* [SimpleLanguage](https://github.com/graalvm/simplelanguage), a toy language implementation to demonstrate Truffle features.

\* Shipped as part of [GraalVM](http://www.oracle.com/technetwork/oracle-labs/program-languages/overview/index.html).

## Experiments

* [ZipPy](https://github.com/securesystemslab/zippy), a Python implementation.
* [TruffleSqueak](https://github.com/timfel/trufflesqueak), an experimental Squeak interpreter.
* [Mumbler](https://github.com/cesquivias/mumbler), an experimental Lisp programming language.
* [LuaTruffle](https://github.com/lucasallan/LuaTruffle), an implementation of the Lua language.
* [hextruffe](https://bitbucket.org/hexafraction/truffles), an implementation of Hex.
* [TruffleMATE](https://github.com/charig/TruffleMATE), a Smalltalk with a completely reified runtime system.
* [PureScript](https://github.com/slamdata/truffled-purescript), a small strongly typed programming language.
* [Mozart-Graal](https://github.com/eregon/mozart-graal), an implementation of the Oz programming language.
* [DynSem](https://github.com/metaborg/dynsem), a DSL for declarative specification of dynamic semantics of languages.
* [Cover](https://github.com/gerard-/cover), a Safe Subset of C++.
* [TrufflePascal](https://github.com/Aspect26/TrufflePascal/), a Pascal interpreter.
* [Reactive Ruby](https://github.com/guidosalva/ReactiveRubyTruffle), TruffleRuby meets Reactive Programming.
* [PorcE](https://github.com/orc-lang/orc/tree/master/PorcE), an Orc language implementation.
* [shen-truffle](https://github.com/ragnard/shen-truffle), a port of the Shen programming language.
* [bf](https://github.com/chumer/bf/), an experimental Brainfuck programming language implementation.
* [brainfuck-jvm](https://github.com/mthmulders/brainfuck-jvm), another Brainfuck language implementation.

Feel free to submit a [pull request](https://help.github.com/articles/using-pull-requests/) to add/remove from this list.
